let sendingFromAddress = document.getElementById("redeemFromBtn");
let transactionFee = document.getElementById("transactionFee");
let defaultBalance = document.getElementById("totalInputValue");
let sendingAddress = document.getElementById("transactionToogle");
let AddressSendingFrom = document.getElementById("AddressSendingFrom");
let address = document.getElementById("sendingAddress");
let addressfinal = document.getElementById("sendingToo");
let totalInput = document.getElementById("totalInput");
let totalInputValue = document.getElementById("ReturningBalance");
let inputval = document.getElementById("valuesub");
let remainval = document.getElementById("ReturningBalance");
// let toVerify = document.getElementById("toVerify");

var transactionBtnLock = false;

sendingAddress.addEventListener("click", function () {

  if (totalInput.innerHTML > transactionFee.value){

    totalInputValue.value = totalInput.innerHTML - transactionFee.value;
    defaultBalance.value  = totalInput.innerHTML - transactionFee.value;

    addressfinal.value   =  address.value;

  }else{

    totalInputValue.value = "0.00000000";
    defaultBalance.value  = totalInput.innerHTML;
    addressfinal.value   =  address.value;

    //Lock input amount
    inputval.setAttribute('readonly', 'readonly');
    inputval.style.backgroundColor = '#c1c1c1fc';

    //Lock Fee
    transactionFee.style.backgroundColor = '#cc8e8e';

    //Lock button build
    transactionBtnLock = true



  }


});

function downloadTextFile(filename, text) {
  var element = document.createElement('a');
  element.setAttribute('href', 'data:text/plain;charset=utf-8,' + encodeURIComponent(text));
  element.setAttribute('download', filename+'.txt');
  element.style.display = 'none';
  document.body.appendChild(element);
  element.click();
  document.body.removeChild(element);
}

$(document).on("input", "#valuesub", function () {

  if (totalInput.innerHTML > transactionFee.value){

    if( parseFloat((inputval.value*1).toFixed(8)) <= parseFloat((totalInput.innerHTML *1 -transactionFee.value*1).toFixed(8)) 
      && parseFloat((inputval.value*1).toFixed(8)) >= parseFloat("0.00000001")){ 




        var fee = (
          totalInput.innerHTML * 1 -
          inputval.value * 1 -
          transactionFee.value * 1
        ).toFixed(8);



        if (fee > 0) {
          remainval.value = fee;
        } else {
          remainval.value = "0.00";
        }








        var fee2 = (
          totalInput.innerHTML * 1 -
          inputval.value * 1 -
          transactionFee.value * 1 -
          totalInputValue.value * 1
        ).toFixed(8);

        if (fee2 > 0) {
          defaultBalance.value = fee2;
        } else {
          defaultBalance.value = "0.00000000";
        }


      inputval.style.backgroundColor = '#fff';
      transactionBtnLock = false



    }else{


      if (parseFloat((inputval.value *1)).toFixed(8) == parseFloat("0")){
        var fee = (
          totalInput.innerHTML * 1 -
          inputval.value * 1 -
          transactionFee.value * 1
        ).toFixed(8);

        remainval.value = fee;

      }





      inputval.style.backgroundColor = '#cc8e8e';
      transactionBtnLock = true



    }

  }

});


$(document).on("input", "#transactionFee", function () {

  if (totalInput.innerHTML > transactionFee.value){

    var tfee = (
      totalInput.innerHTML * 1 -
      inputval.value * 1 -
      transactionFee.value * 1
    ).toFixed(8);


    if (tfee > 0) {
      remainval.value = tfee;
    } else {
      remainval.value = "0.00";
    }




    //Unock input amount
    inputval.removeAttribute('readonly');
    inputval.style.backgroundColor = '#fff';

    //Unock Fee
    transactionFee.style.backgroundColor = '#fff';

    //Unlock button build
    transactionBtnLock = false





  }else{

    //Lock input amount
    inputval.setAttribute('readonly', 'readonly');
    inputval.style.backgroundColor = '#c1c1c1fc';

    //Lock Fee
    transactionFee.style.backgroundColor = '#cc8e8e';

    //Lock button build
    transactionBtnLock = true




  }


});

sendingFromAddress.addEventListener("click", function () {
  let addressFrom = document.getElementById("redeemFrom");
  let addressFromFinal = document.getElementById("sendingfrom");
  addressFromFinal.value = addressFrom.value;
  AddressSendingFrom.value = addressFrom.value;
});

let copyAddress = document.getElementById("copyBtn");
let downloadAddress = document.getElementById("downloadBtn");
let downloadTarDataBtn = document.getElementById("downloadTarDataBtn");
let copySigned = document.getElementById("copySigned");

downloadAddress.addEventListener("click", function () {
  var copyText = document.getElementById("textToCopy");
  var text = copyText.value;
  downloadTextFile('transaction-output', text);
});

copyAddress.addEventListener("click", function () {
  /* Get the text field */
  var copyText = document.getElementById("textToCopy");
  var copyfunc = document.getElementById("copyfunc");

  /* Select the text field */
  copyText.select();
  copyText.setSelectionRange(0, 99999); /* For mobile devices */

  /* Copy the text inside the text field */
  navigator.clipboard.writeText(copyText.value);

  /* Alert the copied text */
  copyfunc.classList.remove("hide-it");
});

downloadTarDataBtn.addEventListener("click", function () {
  var copysignData = document.getElementById("signTarData");
  var text = copysignData.value;
  downloadTextFile('signed-transaction', text);
});

copySigned.addEventListener("click", function () {
  /* Get the text field */
  var copysignData = document.getElementById("signTarData");
  var showSigned = document.getElementById("showSigned");

  /* Select the text field */
  copysignData.select();
  copysignData.setSelectionRange(0, 99999); /* For mobile devices */

  /* Copy the text inside the text field */
  navigator.clipboard.writeText(copysignData.value);

  /* Alert the copied text */
  showSigned.classList.remove("hide-it");
});
$("#transactionBtn").click(function () {
  if(!transactionBtnLock){
    if ($("#transactionFee").val() == 0) {
      alert(
        "You must include a transacation fee to process this transacation on the Bitcoin Blockchain, this fee is paid directly to the miners, if you are unsure of the fee amount, Google Bitcoin transacation fee calculator and do your research."
      );
    }
  }
});

$("#startTarBtn").click(function () {
  $("#welcomeModal").modal("hide");
  $("#myModal").modal("show");
});
$("#signTransactionBtn").click(function () {
  $("#myModal").modal("hide");
  $("#signModal").modal("show");
});
$("#verifyTransactionBtn").click(function () {
  $("#myModal").modal("hide");
  $("#verifyModal").modal("show");
});
$("#broadcastTransactionBtn").click(function () {
  $("#myModal").modal("hide");
  $("#broadcastModal").modal("show");
});
$("#goBackBroadcast").click(function () {
  $("#myModal").modal("show");
  $("#broadcastModal").modal("hide");
});
$("#goBackverify").click(function () {
  $("#myModal").modal("show");
  $("#verifyModal").modal("hide");
});
$("#goBackSign, #goBackSign2").click(function () {
  $("#myModal").modal("show");
  $("#signModal").modal("hide");
});
